#!/usr/bin/perl -w
use Data::Dumper;

$map=$ARGV[0];

open(FD, $ARGV[0]) or die;


while($s=<>){
    $s=~s/[\r\n]+//;
    next if ($s!~/^:(..)(....)(..)(.*?)(..)$/);
    $len=hex($1);
    $addr=hex($2);
    $type=hex($3);
    $code=$4;
    $chk=hex($5);
    #print Dumper($s, $len, $addr, $code, $chk);
    next if ($type!=0);
    for ($i=0;$i<$len;$i++){
        my ($s1)=substr($code, $i*2, 2);
        $code{$addr+$i}=hex($s1);
        $scode{$addr+$i}=$code{$addr+$i}&0x80 ? $code{$addr+$i}-0x100: $code{$addr+$i};
#        printf("Code[%x] = %x\n", $addr+$i, $code{$addr+$i});
    }
}
close(FD);
$chk=$chk;

print Dumper($map);
$map=~s/\..*?$/\.map/;
stdregs();
#print Dumper(%rseg);
if (open (FD, $map)){
    while($s=<FD>){
        $s=~s/[\r\n]+//;
        if ($s!~/^(.SEG)\s+/){
            next;;
        }
        $seg=lc($1);
#        print "==============$seg===============\n";
        <FD>;<FD>;<FD>;
        while($s=<FD>){
#            print Dumper('xx '.$s);
            $s=~s/[\r\n]+//;
            last if ($s=~/^$/);
            next if ($s!~/^\s+([0-9A-F]{2}:)?([0-9A-F]{4})\s+([a-zA-Z0-9_]+)/);
#            print "$2 $3\n";
            $$seg{hex($2)}=$3;
        }
    }
    close(FD);
}else{
    print "Warning: can't open $map\n";
}
#print "\nRSEG\n";
#print Dumper(%rseg);
#print "\nDSEG\n";
#print Dumper(%dseg);

#exit(0);
#print Dumper(%code);
#print Dumper(%dis);

for($addr=0;$addr<0x10000;$addr++){
    next unless defined($code{$addr});
    instruction($addr);
    $addr+=$dil{$addr}-1;
}

$empty=0;
for($addr=0;$addr<0x10000;$addr++){
    if (!defined($code{$addr}) ||
        !defined($dis{$addr})){
        $empty=1;
        next;
    }
    if ($empty){
        printf("\n");
        $empty=0;
    }

    if (defined($cseg{$addr})){
        printf("\n%04x: %s:\n", $addr, $cseg{$addr});
    }
    printf("%04x: ", $addr);
    for ($i=0;$i<3;$i++){
        if ($i<$dil{$addr}){
            printf("%02x ", $code{$addr+$i});
        }else{
            printf("   ");
        }
    
    }
    printf(" %s",$dis{$addr}); 
    printf("\n");
    $addr+=$dil{$addr}-1;
}


sub instruction {
    my ($op)=$code{$addr};
    
    #printf "instruction(%04x) op=%x    ", $addr, $op;

    if ($op==0x00){
        $dis{$addr}="nop";
        $dil{$addr}=1;
    }elsif(($op&0x1f)==0x01){
        $dis{$addr}="ajmp ".acode($addr&0xf800+($op&0xe0)*8+$code{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x02){
#        printf("addr=%04x code1=%02x code2=%02x target=%04x\n", $addr, $code{$addr+1}, $code{$add+2}, $code{$addr+1}*256+$code{$addr+2});
        $dis{$addr}="ljmp ".acode($code{$addr+1}*256+$code{$addr+2});
        $dil{$addr}=3;
    }elsif($op==0x03){
        $dis{$addr}="rr a";
        $dil{$addr}=1;
    }elsif($op==0x04){
        $dis{$addr}="inc a";
        $dil{$addr}=1;
    }elsif($op==0x05){
        $dis{$addr}="inc ".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x06){
        $dis{$addr}="inc ".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x08){
        $dis{$addr}="inc ".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0x10){
        $dis{$addr}="jbc ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif(($op&0x1f)==0x11){
        $dis{$addr}="acall ".acode($addr&0xf800+($op&0xe0)*8+$code{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x12){
        $dis{$addr}="lcall ".acode($code{$addr+1}*256+$code{$addr+2});
        $dil{$addr}=3;
    }elsif($op==0x13){
        $dis{$addr}="rrc a";
        $dil{$addr}=1;
    }elsif($op==0x14){
        $dis{$addr}="dec a";
        $dil{$addr}=1;
    }elsif($op==0x15){
        $dis{$addr}="dec ".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x16){
        $dis{$addr}="dec ".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x18){
        $dis{$addr}="dec ".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0x20){
        $dis{$addr}="jb ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x22){
        $dis{$addr}="ret";
        $dil{$addr}=1;
    }elsif($op==0x23){
        $dis{$addr}="rl a";
        $dil{$addr}=1;
    }elsif($op==0x24){
        $dis{$addr}="add a,".aconst($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x25){
        $dis{$addr}="add a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x26){
        $dis{$addr}="add a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x28){
        $dis{$addr}="add a,".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0x30){
        $dis{$addr}="jnb ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x32){
        $dis{$addr}="reti";
        $dil{$addr}=1;
    }elsif($op==0x33){
        $dis{$addr}="rlc a";
        $dil{$addr}=1;
    }elsif($op==0x34){
        $dis{$addr}="addc a,".aconst($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x35){
        $dis{$addr}="addc a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x36){
        $dis{$addr}="addc a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x38){
        $dis{$addr}="addc a,".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0x40){
        $dis{$addr}="jc ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x42){
        $dis{$addr}="orl ".adirect($addr+1).",a";
        $dil{$addr}=2;
    }elsif($op==0x43){
        $dis{$addr}="orl ".adirect($addr+1).",".aconst($addr+2);  #TODO
        $dil{$addr}=3;
    }elsif($op==0x44){
        $dis{$addr}="orl a,".aconst($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x45){
        $dis{$addr}="orl a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x46){
        $dis{$addr}="orl a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x48){
        $dis{$addr}="orl a,".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0x50){
        $dis{$addr}="jnc ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x52){
        $dis{$addr}="anl ".adirect($addr+1).",a";
        $dil{$addr}=2;
    }elsif($op==0x53){
        $dis{$addr}="anl ".adirect($addr+1).",".aconst($addr+2);#TODO
        $dil{$addr}=3;
    }elsif($op==0x54){
        $dis{$addr}="anl a,".aconst($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x55){
        $dis{$addr}="anl a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x56){
        $dis{$addr}="anl a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x58){
        $dis{$addr}="anl a,".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0x60){
        $dis{$addr}="jz ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x62){
        $dis{$addr}="xlr ".adirect($addr+1).",a";
        $dil{$addr}=2;
    }elsif($op==0x63){
        $dis{$addr}="xlr ".aconst2($addr+1).",".adirect($addr+2); #TODO
        $dil{$addr}=3;
    }elsif($op==0x64){
        $dis{$addr}="xlr a,".aconst($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x65){
        $dis{$addr}="xlr a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x66){
        $dis{$addr}="xlr a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x68){
        $dis{$addr}="xlr a,".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0x70){
        $dis{$addr}="jnz ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x72){
        $dis{$addr}="orl c,".abit($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x73){
        $dis{$addr}="jmp \@a+dptr";
        $dil{$addr}=1;
    }elsif($op==0x74){
        $dis{$addr}="mov a,".aconst($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x75){
        $dis{$addr}="mov ".adirect($addr+1).",".aconst($addr+2); #TODO
        $dil{$addr}=3;
    }elsif(($op&~1)==0x76){
        $dis{$addr}="mov ".ari($addr).",".aconst($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~7)==0x78){
        $dis{$addr}="mov ".arn($addr).",".aconst($addr+1);
        $dil{$addr}=2;

    }elsif($op==0x80){
        $dis{$addr}="sjmp ".acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
    }elsif($op==0x82){
        $dis{$addr}="anl c,".abit($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x83){
        $dis{$addr}="movc a,\@a+pc";
        $dil{$addr}=1;
    }elsif($op==0x84){
        $dis{$addr}="div ab";
        $dil{$addr}=1;
    }elsif($op==0x85){
        $dis{$addr}="mov ".adirect($addr+2).",".adirect($addr+1);
        $dil{$addr}=3;
    }elsif(($op&~1)==0x86){
        $dis{$addr}="mov ".adirect($addr+1).",".ari($addr);
        $dil{$addr}=2;
    }elsif(($op&~7)==0x88){
        $dis{$addr}="mov ".adirect($addr+1).",".arn($addr);
        $dil{$addr}=2;

    }elsif($op==0x90){
        $dis{$addr}="mov dptr,".axram($code{$addr+1}*256+$code{$addr+2});
        $dil{$addr}=3;
    }elsif($op==0x92){
        $dis{$addr}="mov ".abit($addr+1).",c";
        $dil{$addr}=2;
    }elsif($op==0x93){
        $dis{$addr}="movc a,\@a+dptr";
        $dil{$addr}=1;
    }elsif($op==0x94){
        $dis{$addr}="subb a,".aconst($addr+1);
        $dil{$addr}=2;
    }elsif($op==0x95){
        $dis{$addr}="subb a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0x96){
        $dis{$addr}="subb a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0x98){
        $dis{$addr}="subb a,".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0xa0){
        $dis{$addr}="orl c,???";
        $dil{$addr}=1;
    }elsif($op==0xa2){
        $dis{$addr}="mov c,".abit($addr+1);
        $dil{$addr}=2;
    }elsif($op==0xa3){
        $dis{$addr}="inc dptr";
        $dil{$addr}=1;
    }elsif($op==0xa4){
        $dis{$addr}="mul ab";
        $dil{$addr}=1;
    }elsif($op==0xa5){
        $dis{$addr}="db 0xa5";
        $dil{$addr}=1;
    }elsif(($op&~1)==0xa6){
        $dis{$addr}="mov ".ari($addr).",".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~7)==0xa8){
        $dis{$addr}="mov ".arn($addr).",".adirect($addr+1);
        $dil{$addr}=2;

    }elsif($op==0xb0){
        $dis{$addr}="anl c,???";
        $dil{$addr}=1;
    }elsif($op==0xb2){
        $dis{$addr}="cpl ".abit($addr+1);
        $dil{$addr}=2;
    }elsif($op==0xb3){
        $dis{$addr}="cpl c";
        $dil{$addr}=1;
    }elsif($op==0xb4){
        $dis{$addr}="cjne a,".aconst2($addr+1).",".acode($addr+3+$scode{$addr+2});
        $dil{$addr}=3;
    }elsif($op==0xb5){
        $dis{$addr}="cjne a,".adirect($addr+1).",". acode($addr+3+$scode{$addr+2});
        $dil{$addr}=3;
    }elsif(($op&~1)==0xb6){
        $dis{$addr}="cjne ".ari($addr).",".aconst2($addr+1).",". acode($addr+3+$scode{$addr+2});
        $dil{$addr}=3;
    }elsif(($op&~7)==0xb8){
        $dis{$addr}="cjne ".arn($addr).",".aconst2($addr+1).",". acode($addr+3+$scode{$addr+2});
        $dil{$addr}=3;

    }elsif($op==0xc0){
        $dis{$addr}="push ".adirect($addr+1);
        $dil{$addr}=2;
    }elsif($op==0xc2){
        $dis{$addr}="clr ".abit($addr+1);
        $dil{$addr}=2;
    }elsif($op==0xc3){
        $dis{$addr}="clr c";
        $dil{$addr}=1;
    }elsif($op==0xc4){
        $dis{$addr}="swap a";
        $dil{$addr}=1;
    }elsif($op==0xc5){
        $dis{$addr}="xch a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0xc6){
        $dis{$addr}="xch a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0xc8){
        $dis{$addr}="xch a,".arn($addr);
        $dil{$addr}=1;
        
    }elsif($op==0xd0){
        $dis{$addr}="pop ".adirect($addr+1);
        $dil{$addr}=2;
    }elsif($op==0xd2){
        $dis{$addr}="setb ".abit($addr+1);
        $dil{$addr}=2;
    }elsif($op==0xd3){
        $dis{$addr}="setb c";
        $dil{$addr}=1;
    }elsif($op==0xd4){
        $dis{$addr}="da a";
        $dil{$addr}=1;
    }elsif($op==0xd5){
        $dis{$addr}="djnz ".adirect($addr+1).",". acode($addr+3+$scode{$addr+2});
        $dil{$addr}=3;
    }elsif(($op&~1)==0xd6){
        $dis{$addr}="xchd a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0xd8){
        $dis{$addr}="djnz ".arn($addr).",". acode($addr+2+$scode{$addr+1});
        $dil{$addr}=2;
        
    }elsif($op==0xe0){
        $dis{$addr}="movx a,\@dptr";
        $dil{$addr}=1;
    }elsif(($op&~1)==0xe2){
        $dis{$addr}="movx a,".ari($addr);
        $dil{$addr}=1;
    }elsif($op==0xe4){
        $dis{$addr}="clr a";
        $dil{$addr}=1;
    }elsif($op==0xe5){
        $dis{$addr}="mov a,".adirect($addr+1);
        $dil{$addr}=2;
    }elsif(($op&~1)==0xe6){
        $dis{$addr}="mov a,".ari($addr);
        $dil{$addr}=1;
    }elsif(($op&~7)==0xe8){
        $dis{$addr}="mov a,".arn($addr);
        $dil{$addr}=1;

    }elsif($op==0xf0){
        $dis{$addr}="movx \@dptr,a";
        $dil{$addr}=1;
    }elsif(($op&~1)==0xf2){
        $dis{$addr}="mov ".ari($addr).",a";
        $dil{$addr}=1;
    }elsif($op==0xf4){
        $dis{$addr}="cpl a";
        $dil{$addr}=1;
    }elsif($op==0xf5){
        $dis{$addr}="mov ".adirect($addr+1).",a";
        $dil{$addr}=2;
    }elsif(($op&~1)==0xf6){
        $dis{$addr}="mov ".ari($addr).",a";
        $dil{$addr}=1;
    }elsif(($op&~7)==0xf8){
        $dis{$addr}="mov ".arn($addr).",a";
        $dil{$addr}=1;
    }
    #printf ("'%s' len=%d\n",$dis{$addr}, $dil{$addr});
}

sub abit {
    my ($addr)=@_;

    if (defined($bseg{$code{$addr}})){
        return $bseg{$code{$addr}};
    }
    return sprintf("%02xh", $code{$addr}, $code{$addr});
}

sub adirect {
    my ($addr)=@_;
#    printf("adirect($code{$addr})\n");
    if (defined($dseg{$code{$addr}})){
        return $dseg{$code{$addr}};
    }
    if (defined($rseg{$code{$addr}})){
        return $rseg{$code{$addr}};
    }
    if ($code{$addr}<8) {
       return sprintf("RR%d", $code{$addr});
    }
    foreach $key (reverse(sort(keys(%dseg)))){
        next if ($key>$code{$addr});
        return sprintf("%s+%d", $dseg{$key}, $code{$addr}-$key);
        last;
    }
    return sprintf("%02xh", $code{$addr});
}

sub aconst {
    my ($addr)=@_;

    return sprintf("#%02xh    ;#%d", $code{$addr}, $code{$addr});
}

sub aconst2 {
    my ($addr)=@_;

    return sprintf("#%02xh", $code{$addr});
}

sub ari {
    my ($addr)=@_;

    return sprintf("\@R%d", $code{$addr}&1);
}

sub arn {
    my ($addr)=@_;

    return sprintf("R%d", $code{$addr}&7);
}

sub acode {
    my ($addr)=@_;

    if (defined($cseg{$addr})){
        return $cseg{$addr};
    }
    return sprintf("%04x", $addr);
}

sub axram {
    my ($addr)=@_;

    if (defined($xseg{$addr})){
        return $xseg{$addr};
    }
    return sprintf("x%04x", $addr);
}

sub stdregs {
    $rseg{0x80}="P0";
    $rseg{0x81}="SP";
    $rseg{0x82}="DPL";
    $rseg{0x83}="DPH";
    $rseg{0x87}="PCON";
    $rseg{0x88}="TCON";
    $rseg{0x89}="TMOD";
    $rseg{0x8A}="TL0";
    $rseg{0x8B}="TL1";
    $rseg{0x8C}="TH0";
    $rseg{0x8D}="TH1";
    $rseg{0x90}="P1";
    $rseg{0x98}="SCON";
    $rseg{0x99}="SBUF";
    $rseg{0xA0}="P2";
    $rseg{0xA8}="IE";
    $rseg{0xAD}="ET2";
    $rseg{0xB0}="P3";
    $rseg{0xB8}="IP";
    $rseg{0xC8}="T2CON";
    $rseg{0xCA}="RCAP2L";
    $rseg{0xCB}="RCAP2H";
    $rseg{0xCC}="TL2";
    $rseg{0xCD}="TH2";
    $rseg{0xD0}="PSW";
    $rseg{0xE0}="ACC";
    $rseg{0xF0}="B";
    $rseg{0xBD}="PT2";


    $bseg{0x80}="P0_0";
    $bseg{0x81}="P0_1";
    $bseg{0x82}="P0_2";
    $bseg{0x83}="P0_3";
    $bseg{0x84}="P0_4";
    $bseg{0x85}="P0_5";
    $bseg{0x86}="P0_6";
    $bseg{0x87}="P0_7";
    $bseg{0x88}="IT0";
    $bseg{0x89}="IE0";
    $bseg{0x8A}="IT1";
    $bseg{0x8B}="IE1";
    $bseg{0x8C}="TR0";
    $bseg{0x8D}="TF0";
    $bseg{0x8E}="TR1";
    $bseg{0x8F}="TF1";
    $bseg{0x90}="P1_0";
    $bseg{0x91}="P1_1";
    $bseg{0x92}="P1_2";
    $bseg{0x93}="P1_3";
    $bseg{0x94}="P1_4";
    $bseg{0x95}="P1_5";
    $bseg{0x96}="P1_6";
    $bseg{0x97}="P1_7";
    $bseg{0x98}="RI";
    $bseg{0x99}="TI";
    $bseg{0x9A}="RB8";
    $bseg{0x9B}="TB8";
    $bseg{0x9C}="REN";
    $bseg{0x9D}="SM2";
    $bseg{0x9E}="SM1";
    $bseg{0x9F}="SM0";
    $bseg{0xA0}="P2_0";
    $bseg{0xA1}="P2_1";
    $bseg{0xA2}="P2_2";
    $bseg{0xA3}="P2_3";
    $bseg{0xA4}="P2_4";
    $bseg{0xA5}="P2_5";
    $bseg{0xA6}="P2_6";
    $bseg{0xA7}="P2_7";
    $bseg{0xA8}="EX0";
    $bseg{0xA9}="ET0";
    $bseg{0xAA}="EX1";
    $bseg{0xAB}="ET1";
    $bseg{0xAC}="ES";
    $bseg{0xAF}="EA";
    $bseg{0xB0}="P3_0";
    $bseg{0xB1}="P3_1";
    $bseg{0xB2}="P3_2";
    $bseg{0xB3}="P3_3";
    $bseg{0xB4}="P3_4";
    $bseg{0xB5}="P3_5";
    $bseg{0xB6}="P3_6";
    $bseg{0xB7}="P3_7";
    $bseg{0xB0}="RXD";
    $bseg{0xB1}="TXD";
    $bseg{0xB2}="INT0";
    $bseg{0xB3}="INT1";
    $bseg{0xB4}="T0";
    $bseg{0xB5}="T1";
    $bseg{0xB6}="WR";
    $bseg{0xB7}="RD";
    $bseg{0xB8}="PX0";
    $bseg{0xB9}="PT0";
    $bseg{0xBA}="PX1";
    $bseg{0xBB}="PT1";
    $bseg{0xBC}="PS";
    $bseg{0xC8}="CP_RL2";
    $bseg{0xC9}="C_T2";
    $bseg{0xCA}="TR2";
    $bseg{0xCB}="EXEN2";
    $bseg{0xCC}="TCLK";
    $bseg{0xCD}="RCLK";
    $bseg{0xCE}="EXF2";
    $bseg{0xCF}="TF2";
    $bseg{0xD0}="P";
    $bseg{0xD1}="F1";
    $bseg{0xD2}="OV";
    $bseg{0xD3}="RS0";
    $bseg{0xD4}="RS1";
    $bseg{0xD5}="F0";
    $bseg{0xD6}="AC";
    $bseg{0xD7}="CY";
}
